#!/usr/local/bin/perl 

#######################################################
#            Advanced Ranking System V3.0
#  
#
#  By installing and using Advanced Ranking System V3.0, you agree to 
#  be bound by the terms of the software license agreement that 
#  you read while your were purchasing Advanced Ranking System V3.0.
#  You are able to read the software license agreement again at 
#  http://www.cgi-factory.com/advranking/agreement.shtml
#  
##################################################################
#
#               COPYRIGHT NOTICE:
#
#         Copyright 1999 CGI-Factory.com 
#
#      Author:  Yutung Liu
#      web site: http://www.cgi-factory.com
#      E-Mail: cgifactory@cgi-factory.com
#      Software released date: May 1, 1999
#
#   Advanced Ranking System V3.0 is protected by the copyright 
#   laws and international copyright treaties, as well as other 
#   intellectual property laws and treaties. Advanced Ranking  
#   System V3.0 is licensed, not sold.
#
###################################################################

require "cfg.pl";

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $value =~ s/\n/ /g;

        $request{$name} = $value;


}
print "Content-type: text/html\n\n";

&header;

print <<EOF;

<h2>Welcome to $topsite_name</h2>
<form action="$ranking_location" method="post">
<input type="hidden" name="member" value="$request{'member'}">
<input type="hidden" name="score" value="$request{'score'}">
<input type="submit" value="Continue Voting">
</form>

EOF

&footer;

exit;

######################header input

sub header {
	
open (header, "<gheader.txt") or &error("Unable to open the header file");
	
if ($flock eq "y") {

flock header, 2; 

}

@header=<header>;
	
close(header);
	
foreach $header(@header) {
	
print "$header\n";
	
}
}
####################footer input

sub footer {
	
open (footer, "<gfooter.txt") or &error("Unable to open the footer file");
	
if ($flock eq "y") {

flock footer, 2; 

}

@footer=<footer>;
	
close(footer);
	
foreach $footer(@footer) {
	
print "$footer\n";
	
}
}

#####error
sub error {
	
$errors= $_[0];

print "<h2>An error has occured</h2> The error is $errors<br>\n";	
print "$!\n<br><br>";
print "Please contact the webmaster of this web site if you keep getting this message.";	
exit;	
	
	
}
 