#!/usr/local/bin/perl 

#######################################################
#            Advanced Ranking System V3.0
#  
#
#  By installing and using Advanced Ranking System V3.0, you agree to 
#  be bound by the terms of the software license agreement that 
#  you read while your were purchasing Advanced Ranking System V3.0.
#  You are able to read the software license agreement again at 
#  http://www.cgi-factory.com/advranking/agreement.shtml
#  
##################################################################
#
#               COPYRIGHT NOTICE:
#
#         Copyright 1999 CGI-Factory.com 
#
#      Author:  Yutung Liu
#      web site: http://www.cgi-factory.com
#      E-Mail: cgifactory@cgi-factory.com
#      Software released date: May 1, 1999
#
#   Advanced Ranking System V3.0 is protected by the copyright 
#   laws and international copyright treaties, as well as other 
#   intellectual property laws and treaties. Advanced Ranking  
#   System V3.0 is licensed, not sold.
#
###################################################################


require "cfg.pl";

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
	
	($name,$value)=split (/=/,$pair);
    
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $input{$name}=$value;
}

print "Content-type: text/html\n\n";

if (!$input{'create'}) {
&header;
print <<EOF;
<h2>$topsite_name sign up page</h2>
<table border="0">
<tr><td><b>Name of Your web site:</b></td><td><form action="signup.pl" method="POST">
<input type="Text" name="name"></td></tr>
<tr><td><b>SITE URL:</b></td><td><input type="Text" name="url" value="Http://"></td></tr>
<tr><td><b>Description:</b></td><td><input type="Text" name="description"></td></tr>
<tr><td><b>Email:</b></td><td><input type="Text" name="email"></td></tr>
<tr><td><b>Password:</b></td><td><input type="password" name="password1" maxlength="16"></td></tr>
<tr><td><b>Confirm password:</b></td><td><input type="password" name="password2" maxlength="16"></td></tr>
<tr><td><input type="hidden" name="create" value="create"><input type="Submit" value="Submit!"></form></td><td></td></tr>
</table>
EOF
&footer;
exit;
}


#sign up

&ckfield;

open (count, "<count.txt")  or &error("Unable to open the counting file");

if ($flock eq "y") {

flock count, 2; 

}

$count=<count>;

close (count);

if ($count=~ tr/;<>*|`&$!#()[]{}:'"// or $input{'email'}=~ tr/;<>*|`&$!#()[]{}:'"//) {
&header;
print "<h2>Weird symbol</h2>\n";
print "Please don't use weird symbols.<br>\n";
&footer;
exit;
}


$count++;

open (wcount, ">count.txt")  or &error("Unable to write to the counting file");

if ($flock eq "y") {

flock wcount, 2; 

}

print wcount "$count";

close (wcount);

$time=time();

open (members, ">$data_location/$count.dat") or &error("Unable to create the data file");

if ($flock eq "y") {

flock members, 2; 

}

print members "0\n";
print members "0\n";
print members "0\n";
print members "0\n";
print members "$input{'name'}\n";
print members "$input{'url'}\n";
print members "$input{'description'}\n";
print members "$input{'email'}\n";
print members "$password1\n";
print members "$time\n";
print members "0\n";

close(members);

&header;

print "<h2>Welcome to $topsite_name</h2>\n";
print "Thank you for signing up! Your account has been established.<br>\n";
print "Please copy and paste the following html tags onto your page. So your visitors will be able to vote.<br><br>\n";
print "&lt;center&gt;";
print "Vote for our site on $topsite_name!<br>\n";
if ($gate_way==1) {
print "&lt;form action=\"$gateway_cgi\" method=\"POST\"&gt;<br>\n";
}
else {
print "&lt;form action=\"$ranking_location\" method=\"POST\"&gt;<br>\n";
}
print "&lt;select name=\"score\"&gt;<br>";
print "&lt;option value=\"10\"&gt;10- Great<br>\n";
print "&lt;option value=\"9\"&gt;9<br>\n";
print "&lt;option value=\"8\"&gt;8<br>\n";
print "&lt;option value=\"7\"&gt;7<br>\n";
print "&lt;option value=\"6\"&gt;6<br>\n";
print "&lt;option value=\"5\"&gt;5- Fair<br>\n";
print "&lt;option value=\"4\"&gt;4<br>\n";
print "&lt;option value=\"3\"&gt;3<br>\n";
print "&lt;option value=\"2\"&gt;2<br>\n";
print "&lt;option value=\"1\"&gt;1- Poor<br>\n";
print "&lt;/select&gt;<br>\n";
print "&lt;input type=\"hidden\" name=\"member\" value=\"$count\"&gt;<br>\n";
print "&lt;input type=\"Submit\" value=\"Vote!\"&gt;<br>\n";
print "&lt;/form&gt;&lt;/center&gt;<br><br>\n";
print "Once you have pasted the tags on your page. Please click on the vote button to active your account.<br><br>\n";
print "Please write down your account information.<br>\n";
print "<b>ID:</b> $count<br>\n";
print "<b>Password:</b> $input{'password1'}<br><br>\n";
print "You will also receive an email that contains the same information as this page.<br><br>\n";
print "View the ranking list at <a href=\"$page_location\">$page_location</a><br><br>\n";
print "You can modify your account information and view the status of your account at <a href=\"$member_cgi\">$member_cgi</a><br><br>\n";
print "Thank you for participating!<br>\n";
&footer;

open(MAIL,"|$mail_prog") or &error("Unable to open the mail program.");
print MAIL "To: $input{'email'}\n";
print MAIL "From: $youremail\n";
print MAIL "Subject: Welcome to $topsite_name \n\n";
print MAIL "Thank you for signing up! Your account has been established.\n";
print MAIL "Please copy and paste the following html tags on your page. So your visitors will be able to vote.\n\n";
print MAIL "<center>\n";
print MAIL "Vote for our site on $topsite_name!\n";
if ($gate_way==1) {
print MAIL "<form action=\"$gateway_cgi\" method=\"POST\">\n";
}
else {
print MAIL "<form action=\"$ranking_location\" method=\"POST\">\n";
}
print MAIL "<select name=\"score\">\n";
print MAIL "<option value=\"10\">10- Great\n";
print MAIL "<option value=\"9\">9\n";
print MAIL "<option value=\"8\">8\n";
print MAIL "<option value=\"7\">7\n";
print MAIL "<option value=\"6\">6\n";
print MAIL "<option value=\"5\">5- Fair\n";
print MAIL "<option value=\"4\">4\n";
print MAIL "<option value=\"3\">3\n";
print MAIL "<option value=\"2\">2\n";
print MAIL "<option value=\"1\">1- Poor\n";
print MAIL "</select>\n";
print MAIL "<input type=\"hidden\" name=\"member\" value=\"$count\">\n";
print MAIL "<input type=\"Submit\" value=\"Vote!\">\n";
print MAIL "</form></center><br><br>\n";
print MAIL "Once you have pasted the tags on your page. Please click on the vote button to active your account.\n\n";
print MAIL "Please write down your account information.\n";
print MAIL "ID: $count\n";
print MAIL "Password: $input{'password1'}\n\n";
print MAIL "View the ranking list at $page_location\n\n";
print MAIL "You can modify your account information and view the status of your account at $member_cgi\n";
print MAIL "<$member_cgi>\n\n";
print MAIL "Yours sincerely,\n\n";
print MAIL "$topsite_name\n\n";
close (MAIL);

exit;

####check fields
sub ckfield {

if (!$input{'name'}) {
&header;
print "<h2>Unable to create your account</h2>\n";
print "Sorry, you didn't enter the name of your web site.<br>\n";
&footer;	
}

if (!$input{'description'}) {
&header;
print "<h2>Unable to create your account</h2>\n";
print "Sorry, you didn't enter the description of your web site.<br>\n";
&footer;
exit;	
}

if (!$input{'email'}) {
&header;
print "<h2>Unable to create your account</h2>\n";
print "Sorry, you didn't enter your email address.<br>\n";
&footer;
exit;	
}

if (!$input{'url'}) {
&header;
print "<h2>Unable to create your account</h2>\n";
print "Sorry, you didn't enter the URL of your web site.<br>\n";
&footer;
exit;	
}

unless ($input{'email'}=~/.*\@.*/)   { 
&header;
print "<h2>Unable to create your account</h2>\n";
print "Sorry, you entered an invalid email address.<br>\n";
&footer;
exit;
}


unless ($input{'url'}=~/http:/i)   { 
&header;
print "<h2>Unable to create your account</h2>\n";
print "Sorry, you didn't enter the URL of your web site correctly. It must start with \"http://\"<br>\n";
&footer;
exit;
}

if (!$input{'password1'}) {
&header;
print "<h2>Unable to create your account</h2>\n";
print "Sorry, you didn't enter the password.<br>\n";
&footer;
exit;	
}

elsif (!$input{'password2'}) {
&header;
print "<h2>Unable to create your account</h2>\n";
print "Sorry, you didn't enter the password.<br>\n";
&footer;
exit;	
}

else {
$input{'password1'}=~ tr/A-Z/a-z/; 
$password1 = crypt($input{'password1'}, "MM");
$password2 = crypt($input{'password2'}, "MM");	
unless ($password1 eq "$password2") {
&header;
print "<h2>Unable to create your account</h2>\n";
print "Sorry, the two passwords you entered don't match.<br>\n";
&footer;
exit;
}
}
}

######################header input

sub header {
	
open (header, "<sheader.txt") or &error("Unable to open the header file");
if ($flock eq "y") {
flock header, 2; 
}

@header=<header>;
close(header);
	
foreach $header(@header) {
print "$header\n";
}
}
####################footer input

sub footer {
open (footer, "<sfooter.txt") or &error("Unable to open the footer file");
if ($flock eq "y") {
flock footer, 2; 
}
@footer=<footer>;
close(footer);
foreach $footer(@footer) {
print "$footer\n";
}
}

#####error
sub error {
	
$errors= $_[0];

print "<h2>An error has occured</h2> The error is $errors<br>\n";	
print "$!\n<br><br>";
print "Please contact the webmaster of this web site if you keep getting this message.";	
exit;	
	
}