#!/usr/local/bin/perl 

#######################################################
#            Advanced Ranking System V3.0
#  
#
#  By installing and using Advanced Ranking System V3.0, you agree to 
#  be bound by the terms of the software license agreement that 
#  you read while your were purchasing Advanced Ranking System V3.0.
#  You are able to read the software license agreement again at 
#  http://www.cgi-factory.com/advranking/agreement.shtml
#  
##################################################################
#
#               COPYRIGHT NOTICE:
#
#         Copyright 1999 CGI-Factory.com 
#
#      Author:  Yutung Liu
#      web site: http://www.cgi-factory.com
#      E-Mail: cgifactory@cgi-factory.com
#      Software released date: May 1, 1999
#
#   Advanced Ranking System V3.0 is protected by the copyright 
#   laws and international copyright treaties, as well as other 
#   intellectual property laws and treaties. Advanced Ranking  
#   System V3.0 is licensed, not sold.
#
###################################################################

require "cfg.pl";

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $value =~ s/\n/ /g;

        $request{$name} = $value;

if ($value=~ tr/;<>*|`&$!#()[]{}:'"//) {
print "Content-type: text/html\n\n";
print "Security Alert! Action canceled.<br>\n";
print "Please don't use weird symbols\n";
        	
exit;
}
}

$time=time();

if ($ip_logging == 1) {

open (ip, "<ip.txt") or &error("Unable to open the data file- ip.txt");

if ($flock eq "y") {

flock ip, 2; 

}

@ip=<ip>;

close(ip);

foreach $ip(@ip) {

chomp($ip);

@dip=split(/|/, $ip);

if ($ip eq "$ENV{'REMOTE_HOST'}|$request{'member'}") {

print "Content-type: text/html\n\n";
print "<h2>Voting Disallowed</h2>";
print "Our log shows that you have voted already. There is no need to vote again.\n";	
&log_time;
exit;
}
}

open (wip, ">>ip.txt") or &error("Unable to open the data file- ip.txt");
if ($flock eq "y") {
flock wip, 2; 
}

print wip "$ENV{'REMOTE_HOST'}|$request{'member'}\n";
close(wip);
&log_time;
}
	

sub log_time {

open (iptime, "<iptime.txt") or &error("Unable to open the data file- iptime.txt");

if ($flock eq "y") {

flock iptime, 2; 

}

$iptime=<iptime>;
	
close(iptime);

$logtime=$time-$iptime;

if ($logtime>$log_clean) {

open (wiptime, ">iptime.txt") or &error("Unable to write to the data file- iptime.txt");

if ($flock eq "y") {

flock wiptime, 2; 

}

print wiptime "$time";
	
close(wiptime);

	
open (cip, ">ip.txt") or &error("Unable to write to the file- ip.txt");

if ($flock eq "y") {

flock cip, 2; 

}

close(cip);
	
}
}	


if ($gate_way==1) {
	
if( $ENV{'HTTP_REFERER'} ne "$gateway_cgi") { 
print "Content-type: text/html\n\n";
print "<h2>Voting Disallowed</h2>";
print "Sorry, the gateway function is enable. You must vote through the gateway. Please contact";
print " the webmaster of this web site if you keep getting this message.";
exit;

}	
}

$member=$request{'member'};

open (count, "<count.txt")  or &error("Unable to open the counting file");

if ($flock eq "y") {

flock count, 2; 

}

$count=<count>;

close (count);

if (!$member or !$request{'score'}) {
	
print "Location:$page_location\n\n";

exit;	

}

if ($request{'score'}<1 or $request{'score'}>10) {
	
print "Location:$page_location\n\n";

exit;	

}

if ($member>$count) {
	
print "Location:$page_location\n\n";

exit;	

}

#record hit.

if (!$request{'score'}) {

print "Location:$page_location\n\n";

exit;

}

open (members, "<$data_location/$member.dat") or &notfound;

if ($flock eq "y") {

flock members, 2; 

}

@members=<members>;

close(members);

$hit=@members[0];
$score=@members[1];

$hit++;
$score=$score+$request{'score'};
$rate=sprintf("%.2f", $score/$hit);

open (members, ">$data_location/$member.dat") or &error("Unable to create the data file");

if ($flock eq "y") {

flock members, 2; 

}

print members "$hit\n";
print members "$score\n";
print members "$rate\n";
print members @members[3];
print members @members[4];
print members @members[5];
print members @members[6];
print members @members[7];
print members @members[8];
print members @members[9];
print members "1\n";

close(members);

#check time

open (ptime, "<time.txt")  or &error("Unable to open the counting file");

if ($flock eq "y") {

flock ptime, 2; 

}

@ptime=<ptime>;

close(ptime);

$diff=$time-@ptime[0];

if ($diff>=$update_time) {
	
require "update.pl";	
	
}

print "Location:$forward_location\n\n";

exit;

####not found
sub notfound {

print "Location:$page_location\n\n";

exit;	

}

#####error
sub error {
	
$errors= $_[0];

print "<h2>An error has occured</h2> The error is $errors<br>\n";	
print "$!\n<br><br>";
print "Please contact the webmaster of this web site if you keep getting this message.";	
exit;	
	
	
}
 